# slack-timedate

This program implements timedated1 interface from systemd what is
required by GNOME Control Center for now.
slack-timedate's purpose is to make it possible to enjoy full GNOME
functionality on Slackware Linux which doesn't use systemd as its
init-system.

## Installation

```sh
cmake -B build \
  -DCMAKE_INSTALL_PREFIX=/usr \
  -DCMAKE_INSTALL_SYSCONFDIR=/etc
make -C build
make -C build install
```

The installation will create a file `build/install_manifest.txt`, which
contains a list of all files installed in the system. To uninstall the
application those should be removed, for example by doing:

```sh
xargs rm < build/install_manifest.txt
```

## Debugging

Firstly an application is required that changes the time settings over the
timedate1 service. It can be `gnome-control-center` or `kcmshell5 kcm_clock`
for KDE.

Then running `dbus-monitor --system` as root can be used to see the
communication between the control center and this service.

Messages to the D-Bus service can also be sent with `dbus-send`. For example
to get the list of time zones:

```sh
dbus-send --system --print-reply --type=method_call \
  --dest=org.freedesktop.timedate1 \
  /org/freedesktop/timedate1 org.freedesktop.timedate1.ListTimezones
```

To get a value of a property:

```sh
dbus-send --system --print-reply \
  --dest=org.freedesktop.timedate1 \
  /org/freedesktop/timedate1 org.freedesktop.DBus.Properties.Get \
  string:org.freedesktop.timedate1 string:NTP
```

## Dependencies

- glib
- dbus
